/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_FUNC                                                     */
/* Tabela : FUNCIONARIO                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 18/06/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_FUNC
BEFORE INSERT OR UPDATE OR DELETE
ON FUNCIONARIO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUFUNC := SYSDATE;
   END IF;
   IF UPDATING THEN
      :NEW.DTULTATUFUNC := SYSDATE;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('FUNCIONARIO', '', 'CDEMPRESA='||:OLD.CDEMPRESA||';CDFUNC='||:OLD.CDFUNC||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE FUNCIONARIO MODIFY DTULTATUFUNC DEFAULT SYSDATE
/
