IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_GRUPGERENTEOP'   AND
                 TYPE   = 'TR'                   AND
	              U.UID  = O.UID                  AND
	              U.NAME = USER)
DROP TRIGGER LOG_GRUPGERENTEOP
GO


CREATE TRIGGER LOG_GRUPGERENTEOP
ON GRUPGERENTEOP
FOR INSERT, DELETE, UPDATE
AS
   DECLARE  @V_USUARIO      VARCHAR(40);
   DECLARE  @V_TIPO         VARCHAR(1);
   DECLARE  @V_ITPESQ       VARCHAR(40);
   DECLARE  @V_DESC         VARCHAR(300);
   DECLARE  @V_DTOPER       DATETIME;

/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE  @V_ID_COMANDO   VARCHAR(1);

   DECLARE  @V_OLD_CDGRUPGERENTEOP VARCHAR(10);
   DECLARE  @V_OLD_NMGRUPGERENTEOP VARCHAR(50);

   DECLARE  @V_NEW_CDGRUPGERENTEOP VARCHAR(10);
   DECLARE  @V_NEW_NMGRUPGERENTEOP VARCHAR(50);

BEGIN

   SET @V_TIPO = '0';
   SET @V_DESC = '';
   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
      'D' IDCOMANDO,
      CDGRUPGERENTEOP,
      NMGRUPGERENTEOP,
      NULL,
      NULL
   FROM
      DELETED
   WHERE CDGRUPGERENTEOP NOT IN (SELECT CDGRUPGERENTEOP FROM INSERTED)

   UNION ALL

   SELECT
      'U' IDCOMANDO,
      DELETED.CDGRUPGERENTEOP,
      DELETED.NMGRUPGERENTEOP,

      INSERTED.CDGRUPGERENTEOP,
      INSERTED.NMGRUPGERENTEOP
   FROM
      INSERTED,
      DELETED
   WHERE INSERTED.CDGRUPGERENTEOP  = DELETED.CDGRUPGERENTEOP
   UNION ALL

   SELECT
      'I' IDCOMANDO,

      NULL,
      NULL,
      CDGRUPGERENTEOP,
      NMGRUPGERENTEOP
   FROM
      INSERTED
   WHERE CDGRUPGERENTEOP NOT IN (SELECT CDGRUPGERENTEOP FROM DELETED)
   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_OLD_CDGRUPGERENTEOP,
                                 @V_OLD_NMGRUPGERENTEOP,
                                 @V_NEW_CDGRUPGERENTEOP,
                                 @V_NEW_NMGRUPGERENTEOP;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' BEGIN
         IF @V_OLD_CDGRUPGERENTEOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdGerenteOp=' + @V_OLD_CDGRUPGERENTEOP;
         END;
         IF @V_OLD_NMGRUPGERENTEOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NmGerenteop=' + @V_OLD_NMGRUPGERENTEOP;
         END;
         SET @V_TIPO         = '3';
         SET @V_ITPESQ       = @V_OLD_CDGRUPGERENTEOP;
      END
      ELSE BEGIN
         IF @V_ID_COMANDO = 'U' BEGIN
            IF (@V_OLD_NMGRUPGERENTEOP <> @V_NEW_NMGRUPGERENTEOP) BEGIN
               SET @V_DESC = @V_DESC + ' NmGerenteop=' + @V_NEW_NMGRUPGERENTEOP;

               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_CDGRUPGERENTEOP;
            END;
         END
         ELSE BEGIN
            SET @V_TIPO         = '1';
            SET @V_ITPESQ       = @V_NEW_CDGRUPGERENTEOP;

            IF ISNULL(@V_NEW_CDGRUPGERENTEOP,'!') <> ISNULL(@V_OLD_CDGRUPGERENTEOP,'!') BEGIN
               SET @V_DESC = @V_DESC + ' CdGerenteOp=' + @V_NEW_CDGRUPGERENTEOP;
            END;

            IF ISNULL(@V_NEW_NMGRUPGERENTEOP ,'!') <> ISNULL(@V_NEW_NMGRUPGERENTEOP, '!') BEGIN
               SET @V_DESC = @V_DESC + ' NmGerenteOP=' + @V_NEW_NMGRUPGERENTEOP;
            END;
         END;
      END;

      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();
               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                  ('GRUPGERENTEOP',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO,      @V_ITPESQ, @V_DESC);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_OLD_CDGRUPGERENTEOP,
                                    @V_OLD_NMGRUPGERENTEOP,

                                    @V_NEW_CDGRUPGERENTEOP,
                                    @V_NEW_NMGRUPGERENTEOP;

   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_GRUPGERENTEOP','5.09.000';
GO

